package com.ghn.recipiedemo.portfolio.data.models

import android.os.Parcelable
import com.squareup.moshi.Json
import kotlinx.android.parcel.Parcelize

@Parcelize
data class Quote(
    @field:Json(name = "symbol") val symbol: String,
    @field:Json(name = "companyName") val companyName: String,
    @field:Json(name = "primaryExchange") val primaryExchange: String,
    @field:Json(name = "calculationPrice") val calculationPrice: String,
    @field:Json(name = "open") val openPrice: Double?,
    @field:Json(name = "openTime") val openTime: Long?,
    @field:Json(name = "close") val close: Double?,
    @field:Json(name = "closeTime") val closeTime: Long?,
    @field:Json(name = "high") val high: Double?,
    @field:Json(name = "low") val low: Double?,
    @field:Json(name = "latestPrice") val latestPrice: Double?,
    @field:Json(name = "latestSource") val latestSource: String?,
    @field:Json(name = "latestTime") val latestTime: String,
    @field:Json(name = "latestUpdate") val latestUpdate: Long,
    @field:Json(name = "latestVolume") val latestVolume: Int?,
    @field:Json(name = "iexRealtimePrice") val iexRealtimePrice: Double?,
    @field:Json(name = "iexRealtimeSize") val iexRealtimeSize: Double?,
    @field:Json(name = "iexLastUpdated") val iexLastUpdated: Double?,
    @field:Json(name = "delayedPrice") val delayedPrice: Double?,
    @field:Json(name = "delayedPriceTime") val delayedPriceTime: Long?,
    @field:Json(name = "oddLotDelayedPrice") val oddLotDelayedPrice: Double?,
    @field:Json(name = "oddLotDelayedPriceTime") val oddLotDelayedPriceTime: Long?,
    @field:Json(name = "extendedPrice") val extendedPrice: Double?,
    @field:Json(name = "extendedChange") val extendedChange: Double?,
    @field:Json(name = "extendedChangePercent") val extendedChangePercent: Double?,
    @field:Json(name = "extendedPriceTime") val extendedPriceTime: Long?,
    @field:Json(name = "previousClose") val previousClose: Double?,
    @field:Json(name = "previousVolume") val previousVolume: Int?,
    @field:Json(name = "change") val change: Double?,
    @field:Json(name = "changePercent") val changePercent: Double?,
    @field:Json(name = "volume") val volume: Int?,
    @field:Json(name = "iexMarketPercent") val iexMarketPercent: Double?,
    @field:Json(name = "iexVolume") val iexVolume: Double?,
    @field:Json(name = "avgTotalVolume") val avgTotalVolume: Int?,
    @field:Json(name = "iexBidPrice") val iexBidPrice: Double?,
    @field:Json(name = "iexBidSize") val iexBidSize: Double?,
    @field:Json(name = "iexAskPrice") val iexAskPrice: Double?,
    @field:Json(name = "iexAskSize") val iexAskSize: Double?,
    @field:Json(name = "marketCap") val marketCap: Long?,
    @field:Json(name = "peRatio") val peRatio: Double?,
    @field:Json(name = "week52High") val week52High: Double?,
    @field:Json(name = "week52Low") val week52Low: Double?,
    @field:Json(name = "ytdChange") val ytdChange: Double?,
    @field:Json(name = "lastTradeTime") val lastTradeTime: Long?,
    @field:Json(name = "isUSMarketOpen") val isUSMarketOpen: Boolean
) : Parcelable {
    fun mapToQuoteModule() = QuoteModule(
        symbol = symbol,
        companyName = companyName,
        primaryExchange = primaryExchange,
        calculationPrice = calculationPrice,
        openPrice = openPrice,
        openTime = openTime,
        close = close,
        closeTime = closeTime,
        high = high,
        low = low,
        latestPrice = latestPrice,
        latestSource = latestSource,
        latestTime = latestTime,
        latestUpdate = latestUpdate,
        latestVolume = latestVolume,
        iexRealtimePrice = iexRealtimePrice,
        iexRealtimeSize = iexRealtimeSize,
        iexLastUpdated = iexLastUpdated,
        delayedPrice = delayedPrice,
        delayedPriceTime = delayedPriceTime,
        oddLotDelayedPrice = oddLotDelayedPrice,
        oddLotDelayedPriceTime = oddLotDelayedPriceTime,
        extendedPrice = extendedPrice,
        extendedChange = extendedChange,
        extendedChangePercent = extendedChangePercent,
        extendedPriceTime = extendedPriceTime,
        previousClose = previousClose,
        previousVolume = previousVolume,
        change = change,
        changePercent = changePercent,
        volume = volume,
        iexMarketPercent = iexMarketPercent,
        iexVolume = iexVolume,
        avgTotalVolume = avgTotalVolume,
        iexBidPrice = iexBidPrice,
        iexBidSize = iexBidSize,
        iexAskPrice = iexAskPrice,
        iexAskSize = iexAskSize,
        marketCap = marketCap,
        peRatio = peRatio,
        week52High = week52High,
        week52Low = week52Low,
        ytdChange = ytdChange,
        lastTradeTime = lastTradeTime,
        isUSMarketOpen = isUSMarketOpen
    )
}
